# GameOptionsWindow Struct Reference

Inheritance diagram for GameOptionsWindow:

## Public Member Functions
| GameOptionsWindow (const WindowDesc *desc)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
template<class T >
void | SetMediaSet (int index)
| Set the base media set.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.
## Data Fields
GameSettings * | opt
bool | reload

## Detailed Description

Definition at line 166 of file settings_gui.cpp.

## Member Function Documentation

virtual void GameOptionsWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 209 of file settings_gui.cpp.

References DrawStringMultiLine(), GetCurrentLanguageIsoCode(), BaseMedia< MusicSet >::GetUsedSet(), BaseMedia< SoundsSet >::GetUsedSet(), BaseMedia< GraphicsSet >::GetUsedSet(), GOW_BASE_GRF_DESCRIPTION, GOW_BASE_MUSIC_DESCRIPTION, GOW_BASE_SFX_DESCRIPTION, and SetDParamStr().

virtual void GameOptionsWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 280 of file settings_gui.cpp.

References _dynlang, _network_server, _networking, _settings_client, GUISettings::autosave, BuildCurrencyDropdown(), DynamicLanguages::curr, LocaleSettings::currency, GameSettings::game_creation, GetMaskOfAllowedCurrencies(), GOW_AUTOSAVE_DROPDOWN, GOW_BASE_GRF_DROPDOWN, GOW_BASE_MUSIC_DROPDOWN, GOW_BASE_SFX_DROPDOWN, GOW_CURRENCY_DROPDOWN, GOW_DISTANCE_DROPDOWN, GOW_FULLSCREEN_BUTTON, GOW_LANG_DROPDOWN, GOW_RESOLUTION_DROPDOWN, GOW_ROADSIDE_DROPDOWN, GOW_SCREENSHOT_DROPDOWN, GOW_TOWNNAME_DROPDOWN, ClientSettings::gui, INVALID_STRING_ID, GameSettings::locale, DynamicLanguages::num, VehicleSettings::road_side, RoadVehiclesAreBuilt(), Window::SetDirty(), Window::SetWidgetLoweredState(), ShowDropDownList(), ShowDropDownMenu(), ShowErrorMessage(), ShowTownnameDropdown(), GameCreationSettings::town_name, LocaleSettings::units, and GameSettings::vehicle.

virtual void GameOptionsWindow::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 378 of file settings_gui.cpp.

References _settings_client, GUISettings::autosave, CheckForMissingGlyphsInLoadedLanguagePack(), LocaleSettings::currency, GameSettings::game_creation, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_town_pool >::GetNumItems(), GetSettingFromName(), GOW_AUTOSAVE_DROPDOWN, GOW_BASE_GRF_DROPDOWN, GOW_BASE_MUSIC_DROPDOWN, GOW_BASE_SFX_DROPDOWN, GOW_CURRENCY_DROPDOWN, GOW_DISTANCE_DROPDOWN, GOW_LANG_DROPDOWN, GOW_RESOLUTION_DROPDOWN, GOW_ROADSIDE_DROPDOWN, GOW_SCREENSHOT_DROPDOWN, GOW_TOWNNAME_DROPDOWN, ClientSettings::gui, Window::height, GameSettings::locale, MarkWholeScreenDirty(), ReInitAllWindows(), VehicleSettings::road_side, Window::SetDirty(), SetSettingValue(), SetWindowDirty(), GameCreationSettings::town_name, LocaleSettings::units, UpdateAllVirtCoords(), GameSettings::vehicle, and Window::width.

virtual void GameOptionsWindow::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 445 of file settings_gui.cpp.

References BaseSet< T, Tnum_files, Tsubdir >::GetNumInvalid(), BaseSet< T, Tnum_files, Tsubdir >::GetNumMissing(), BaseMedia< MusicSet >::GetUsedSet(), BaseMedia< GraphicsSet >::GetUsedSet(), GOW_BASE_GRF_STATUS, GOW_BASE_MUSIC_STATUS, GOW_FULLSCREEN_BUTTON, SetDataTip(), and Window::SetWidgetLoweredState().

virtual void GameOptionsWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 204 of file settings_gui.cpp.

References Window::DrawWidgets().

template<class T >

void GameOptionsWindow::SetMediaSet | ( | int | index | ) | `[inline]`

Set the base media set.

Parameters:

  | index | the index of the media set

Template Parameters:

  | T | class of media set

Definition at line 364 of file settings_gui.cpp.

References Window::InvalidateData().

virtual void GameOptionsWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 185 of file settings_gui.cpp.

References _dynlang, _settings_client, GUISettings::autosave, DynamicLanguages::curr, LocaleSettings::currency, GameSettings::game_creation, BaseMedia< MusicSet >::GetUsedSet(), BaseMedia< SoundsSet >::GetUsedSet(), BaseMedia< GraphicsSet >::GetUsedSet(), GOW_AUTOSAVE_DROPDOWN, GOW_BASE_GRF_DROPDOWN, GOW_BASE_GRF_STATUS, GOW_BASE_MUSIC_DROPDOWN, GOW_BASE_MUSIC_STATUS, GOW_BASE_SFX_DROPDOWN, GOW_CURRENCY_DROPDOWN, GOW_DISTANCE_DROPDOWN, GOW_LANG_DROPDOWN, GOW_RESOLUTION_DROPDOWN, GOW_ROADSIDE_DROPDOWN, GOW_SCREENSHOT_DROPDOWN, GOW_TOWNNAME_DROPDOWN, ClientSettings::gui, GameSettings::locale, VehicleSettings::road_side, SetDParam(), SetDParamStr(), GameCreationSettings::town_name, LocaleSettings::units, and GameSettings::vehicle.

virtual void GameOptionsWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 229 of file settings_gui.cpp.

References GetCurrentLanguageIsoCode(), BaseSet< T, Tnum_files, Tsubdir >::GetNumInvalid(), BaseMedia< MusicSet >::GetNumSets(), BaseMedia< SoundsSet >::GetNumSets(), BaseMedia< GraphicsSet >::GetNumSets(), BaseMedia< MusicSet >::GetSet(), BaseMedia< SoundsSet >::GetSet(), BaseMedia< GraphicsSet >::GetSet(), GetStringBoundingBox(), GetStringHeight(), GOW_BASE_GRF_DESCRIPTION, GOW_BASE_GRF_STATUS, GOW_BASE_MUSIC_DESCRIPTION, GOW_BASE_MUSIC_STATUS, GOW_BASE_SFX_DESCRIPTION, max(), maxdim(), SetDParam(), and SetDParamStr().

The documentation for this struct was generated from the following file:

- src/settings_gui.cpp